import java.util.NoSuchElementException;

public class List {

    private ListElem anchor;

    public List() {
    }
        
    public List(ListElem anchor) {
        this.anchor = anchor;
    }
        
    public List(Object o) {
        this(new ListElem(o));
    }

    public String toString() {
        ListIterator iter = iterator();
        String result = "<";
        if (iter.hasNext()) {
            result += iter.next();
        }
        while (iter.hasNext()) {
            result += ", " + iter.next();
        }
        result += ">";
        return result;
    }

    public void clear() {
        anchor = null;
    }

    public void addFirst(Object o) {
        anchor = new ListElem(o, anchor);
    }

    public Object removeFirst() throws NoSuchElementException {
        if (anchor == null) {
            throw new NoSuchElementException();
        }
        else {
            Object result = anchor.getValue();
            anchor = anchor.getTail();
            return result;
        }
    }

    public ListIterator iterator() {
        return new ListIterator(this.anchor);
    }

    public int size() {
        int result = 0;
        ListIterator iter = iterator();
        while(iter.hasNext()) {
            result++;
            iter.next();
        }
        return result;
    }

    public boolean contains(Object o) {
        ListIterator iter = iterator();
        while (iter.hasNext()) {
            if (iter.next().equals(o))
                return true;
        }
        return false;
    }

    public void reverse() {
        ListElem newAnchor = null;
        ListIterator iter = iterator();
        while(iter.hasNext()) {
            newAnchor = new ListElem(iter.next(),newAnchor);
        }
        anchor = newAnchor;
    }
        
    public boolean equals(Object o) {
        try {
            ListIterator iter1 = iterator();
            ListIterator iter2 = ((List)o).iterator();
            while (iter1.hasNext() && iter2.hasNext()) {
                if (!iter1.next().equals(iter2.next()))
                    return false;
            }
            if (iter1.hasNext() != iter2.hasNext())
                return false;
            else
                return true;
        }
        catch(Exception e) {
            return false;
        }
    }

    public boolean isEmpty() {
    	return anchor == null;
    }
    
    public void append(List al) {
        if (anchor == null) {
            anchor = al.anchor;
        }
        else {
            ListElem lastElem = anchor.findLastElem();
            lastElem.setTail(al.anchor);                 
        }
    }
    
    public Object get(int index) throws NoSuchElementException{
    	ListElem current = anchor;
    	int i = 0;
    	while (current != null) {
    		if (i == index) {
    			return current.getValue();
    		}
    		i++;
    		current = current.getTail();
    	}
    	throw new NoSuchElementException();
    }
    
    public Object getFirst() throws NoSuchElementException {
    	if (anchor != null)
    		return anchor.getValue();
    	else {
    		throw new NoSuchElementException();
    	}
    }
    
    public List sharedRest() throws NoSuchElementException {
    	if (this.size() <= 1)
    		throw new NoSuchElementException();
    	else {
    		ListElem e = anchor.getTail();
    		return new List(e);
    	}
    }
}















